package nl.nikhef.safaripark.dolly;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.Reader;
import java.util.Properties;

import nl.nikhef.sfp.ddmi.DDMIValue;
import nl.nikhef.tools.Utils;

public class FileValueGetter implements ValueGetter {

	private Properties _props = new Properties();
	
	public FileValueGetter(File sourceFile) throws IOException {
		
		Reader r = new FileReader(sourceFile);
		try {
			_props.load(r);
		} finally {
			try {
				r.close();
			} catch (IOException e) {};
		}
	}

	@Override
	public byte[] getValue(DDMIValue v) {
		
		String name = v.getQualifiedName();
		
		String prop = _props.getProperty(name, null);
		
		if (prop == null) return null;
		
		return Utils.hexStringToBytes(prop);
	}

}
